Imports System.Data.OleDb
Imports System.Drawing.Drawing2D
Imports System.Resources
Imports System.IO


Public Class Hang
    Private Const RES_FILENAME As String = "my.resources"


    Private ds As New DataSet
    Private connString As String
    Private da As OleDb.OleDbDataAdapter
    Private dv As DataView

    Protected EquipmentSelections() As Button
    Dim Quincy As Boolean
    Dim Dusty As Boolean 'Verhindert die Auswahl neuer Begriffe bevor zu Ende gespiet wurde
    Dim Modified As Boolean



    Private Sub Hang_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        ' Resource_Datei erstellen und Strings anfgen
        WriteRessource()

        Application.Exit()
    End Sub



    Private Sub Hang_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Left = CInt((Screen.PrimaryScreen.WorkingArea.Width - Me.Width) / 2)
        Me.Top = CInt((Screen.PrimaryScreen.WorkingArea.Height - Me.Height) / 2)
        ' Wenn Ressource existiert, dann auslesen
        If File.Exists(Application.StartupPath & "\" & RES_FILENAME) Then
            ReadRessource()
        End If



        Panel1.Visible = False
        Lade_DB()
        TextBox5.Text = "0"
        TextBox6.Text = "0"
        TextBox7.Text = "0"
        TextBox11.Text = "0"
        'Bedingung dafr das Punkte vergeben werden knnen
        Quincy = True
        Dusty = True


        ' Array mit vorhandenen Button anlegen
        EquipmentSelections = New Button() _
              {btn1, btn2, btn3, btn4, btn5, btn6, btn7, btn8, btn9, btn10, _
               btn11, btn12, btn13, btn14, btn15, btn16, btn17, btn18, btn19, _
               btn20, btn21, btn22, btn23, btn24, btn25, btn26}


        ' Array durchlaufen und jeden Button an gemeinsamen
        ' Click - Event - Handler binden


        For Each btn As Button In EquipmentSelections

            AddHandler btn.Click, _
            New EventHandler(AddressOf SelectionChanged)
        Next

    End Sub

    ' Resource_Datei erstellen und Strings anfgen
    Private Sub WriteRessource()
        Dim rw As ResourceWriter = New ResourceWriter(RES_FILENAME)

        rw.AddResource("1", TextBox8.Text)
        rw.AddResource("2", TextBox9.Text)
        rw.AddResource("3", TextBox10.Text)

        rw.Close()
    End Sub

    ' Ressource lesen
    Private Sub ReadRessource()
        Dim rr As ResourceReader = New ResourceReader(RES_FILENAME)
        Dim dict As IDictionaryEnumerator = rr.GetEnumerator()

        While dict.MoveNext()
            Select Case dict.Key.ToString
                Case 1
                    TextBox8.Text = dict.Value.ToString()
                Case 2
                    TextBox9.Text = dict.Value.ToString()
                Case 3
                    TextBox10.Text = dict.Value.ToString()

            End Select

        End While

        rr.Close()
    End Sub

    ' Hintergrund-Farbverlauf erstellen
    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        ' Gre der Form
        Dim oRect As New Rectangle(0, 0, Me.Width, Me.Height)

        ' Neues Brush-Objekt mit den gewnschten Farben und 
        ' Farbverlauf-Richtung erstellen
        Dim oBrush As New LinearGradientBrush(oRect, Color.Black, Color.White, _
          LinearGradientMode.ForwardDiagonal)

        ' Hintergrund-Farbverlauf anzeigen
        e.Graphics.FillRectangle(oBrush, oRect)


        Dim fnt As New Font("Serifa BT", 23)
        Dim text As String = "Name           Pkt.       Moves"
        Dim offset As Integer = 2
        Dim g As Graphics = e.Graphics

        g.TranslateTransform(-offset, 25)


        ' Anhebung zeichnen
        g.DrawString(text, fnt, Brushes.Black, 328, 70)

        ' Normalbereich zeichnen
        g.TranslateTransform(-offset, -offset)
        g.DrawString(text, fnt, Brushes.Red, 328, 70)


    End Sub

    Private Sub Lade_DB()
        connString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Application.StartupPath & "\Hnger.mdb"

        Dim conn As New OleDb.OleDbConnection(connString)
        Dim sql As String = "SELECT * FROM Worte ORDER BY Zufall"
        da = New OleDb.OleDbDataAdapter(sql, conn)
        Dim cb As New OleDb.OleDbCommandBuilder(da)

        Try

            da.Fill(ds, "Worte")
        Catch ex As System.Exception
            MsgBox(ex.ToString())
            Return
        End Try
        dv = ds.Tables("Worte").DefaultView



        TextBox1.DataBindings.Add("Text", dv, "Begriff")
        TextBox2.DataBindings.Add("Text", dv, "Zufall")
        TextBox3.DataBindings.Add("Text", dv, "ID")

        'Die Daten werden bis zum letzgenutzten Wert hochgeladen
        Dim move As Double
        move = TextBox10.Text

        Me.BindingContext(dv).Position += move



    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim ctl As Control


        If Dusty = False Then
            Dim msg As String
            Dim title As String
            Dim style As MsgBoxStyle
            Dim response As MsgBoxResult
            msg = "Bitte zu Ende spielen!!!"

            style = MsgBoxStyle.DefaultButton2 Or _
            MsgBoxStyle.Critical Or MsgBoxStyle.OkOnly
            title = "Achtung"
            response = MsgBox(msg, style, title)
        Else


            'Die Aufgabe wird fortbewegt
            Me.BindingContext(dv).Position += 1

            'in Textbox10 ist die Anzahl der Moves ersichtlich
            TextBox10.Text = (Convert.ToDouble(TextBox10.Text + 1))

            TextBox5.Text = "0"
            TextBox6.Text = "0"
            TextBox7.Text = "0"

            For Each ctl In Me.Controls
                If ctl.Name.StartsWith("btn") = True Then
                    ctl.Enabled = True
                End If
            Next


            Aufgabe()
        End If
    End Sub

    Private Sub Aufgabe()

        TextBox11.Text = 0
        Dim ctl As Control

        'Der Galgen wird unsichtbar gemacht
        For Each ctl In Me.Controls
            If ctl.Name.StartsWith("pic") = True Then
                ctl.Visible = False
            End If
        Next

        'Zu Beginn mssen die Buchstaben unsichtbar sein
        For Each ctl In Me.Controls
            If ctl.Name.StartsWith("kn") = True Then
                ctl.Text = String.Empty
                ctl.ForeColor = Color.White

            End If
        Next
        'Alle (20)Buchstabenfelder sind sichtbar
        For Each ctl In Me.Controls
            If ctl.Name.StartsWith("kn") = True Then
                ctl.Visible = True
            End If
        Next

        '"Tastatur" wird wieder sichtbar
        For Each btn As Button In EquipmentSelections
            btn.Visible = True
        Next


        Try
            Dim S As String
            S = TextBox1.Text


            'Der Datenbankbegriff wird in einzelne Buttons aufgeteilt
            For i As Int32 = 1 To 20
                Me.Controls("kn" & i.ToString).Text = TextBox1.Text.Chars(i - 1).ToString
            Next

        Catch
            Exit Try
        End Try


        'Die nichtbentigten "Buchstaben" werden gelscht
        For Each ctl In Me.Controls
            If ctl.Name.StartsWith("kn") = True Then
                If ctl.Text = "" Then ctl.Visible = False

            End If

        Next


        'Die Anzahl der sichtbaren Buchstaben wird ermittelt

        For Each ctl In Me.Controls
            If ctl.Name.StartsWith("kn") = True Then
                If ctl.Visible = True Then
                    TextBox11.Text = (Convert.ToDouble(TextBox11.Text + 1))
                End If
            End If
        Next

        Dusty = False

    End Sub


    Private Sub SelectionChanged(ByVal sender As Object, _
    ByVal e As System.EventArgs)
        'Hier werden Textbox 7 und 5 gleichgesetzt
        TextBox7.Text = TextBox5.Text
        Dim ctl As Control
        For Each btn As Button In EquipmentSelections
            btn = (CType(sender, Button))
            For Each ctl In Me.Controls
                If ctl.Name.StartsWith("kn") = True Then
                    If ctl.Text = btn.Text Then
                        ctl.ForeColor = Color.Black
                        'Hier wird bei Treffern Textbox5 hochgerechnet
                        'Da es 26 Buchstaben sind(for each) immer um 26 ***
                        TextBox5.Text = (Convert.ToDouble(TextBox5.Text) + 1)
                    End If
                End If

            Next
            'Die gedrckten Tasten verschwinden, damit sie nicht noch mal benutzt werden knnen
            sender.Visible = False

        Next
        'Bei Nichttreffern bleiben die beiden Textboxen gleich
        If TextBox7.Text = TextBox5.Text Then TextBox6.Text = (Convert.ToDouble(TextBox6.Text) + 1)



        '***hier werden die Treffer mit den sichtbaren Buchstaben verglichen
        If TextBox11.Text = (Convert.ToDouble(TextBox5.Text / 26)) Then

            PictureBox1.Visible = True

            MsgBox("Sie haben gewonnen!")
            Dusty = True
            Quincy = True
            If Quincy = True Then TextBox9.Text = (Convert.ToDouble(TextBox9.Text) + (Convert.ToDouble(TextBox5.Text / 26)))
            PictureBox1.Visible = False
            'Der Galgen wird unsichtbar gemacht
            For Each ctl In Me.Controls
                If ctl.Name.StartsWith("pic") = True Then
                    ctl.Visible = False
                End If
            Next

        End If



    End Sub

    Private Sub NeueBegriffeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeueBegriffeToolStripMenuItem.Click
        Eingabe.Show()
    End Sub
 


    Private Sub TextBox6_TextChanged_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox6.TextChanged
        Select Case TextBox6.Text
            Case 1
                pic1.Visible = True : pic2.Visible = True
            Case 2
                pic3.Visible = True : pic4.Visible = True
            Case 3
                pic5.Visible = True
            Case 4
                pic6.Visible = True
            Case 5
                pic7.Visible = True
            Case 6
                pic8.Visible = True
                MsgBox("Sie haben verloren! Strafe muss sein!")
                Quincy = False
                Dusty = True
                'Hier (bei der - 15 kann man der Schweregrad einstellen)
                TextBox9.Text = (Convert.ToDouble(TextBox9.Text - 15))

                For Each btn As Button In EquipmentSelections
                    btn.Visible = False
                Next


        End Select

    End Sub



    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim msg As String
        Dim title As String
        Dim style As MsgBoxStyle
        Dim response As MsgBoxResult
        msg = "Wollen Sie wirklich Name, Punkte und Moves lschen?"
        style = MsgBoxStyle.DefaultButton2 Or _
           MsgBoxStyle.Critical Or MsgBoxStyle.YesNo
        title = "Lschen"
        response = MsgBox(msg, style, title)
        If response = MsgBoxResult.Yes Then
            TextBox8.Text = ""
            TextBox9.Text = "0"
            TextBox10.Text = "0"


        End If
        If response = MsgBoxResult.No Then Exit Sub

    End Sub

    Private Sub PunkteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PunkteToolStripMenuItem.Click
        Punkte.Show()
    End Sub

 

End Class
