Imports System.Data.OleDb
Imports System.Drawing.Drawing2D


Public Class Punkte


    Private ds As New DataSet
    Private connString As String
    Private da As OleDb.OleDbDataAdapter
    Private dv As DataView
    Private objCB As OleDb.OleDbCommandBuilder


    Private Sub Punkte_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Left = CInt((Screen.PrimaryScreen.WorkingArea.Width - Me.Width) / 2)
        Me.Top = CInt((Screen.PrimaryScreen.WorkingArea.Height - Me.Height) / 2)
        Lade_DB()
        Zahlzeigen()
    End Sub
    Private Sub Zahlzeigen()
        Me.Label1.Text = (((Me.BindingContext(dv).Position + 1).ToString + " von  ") _
                    + Me.BindingContext(dv).Count.ToString)

    End Sub
    ' Hintergrund-Farbverlauf erstellen
    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        ' Gre der Form
        Dim oRect As New Rectangle(0, 0, Me.Width, Me.Height)

        ' Neues Brush-Objekt mit den gewnschten Farben und 
        ' Farbverlauf-Richtung erstellen
        Dim oBrush As New LinearGradientBrush(oRect, Color.White, Color.Black, _
          LinearGradientMode.ForwardDiagonal)

        ' Hintergrund-Farbverlauf anzeigen
        e.Graphics.FillRectangle(oBrush, oRect)

        Dim fnt As New Font("Serifa BT", 23)
        Dim text As String = " Name           Pkt.      Moves   Datum"
        Dim offset As Integer = 2
        Dim g As Graphics = e.Graphics

        g.TranslateTransform(-offset, 25)


        ' Anhebung zeichnen
        g.DrawString(text, fnt, Brushes.Black, 66, 20)

        ' Normalbereich zeichnen
        g.TranslateTransform(-offset, -offset)
        g.DrawString(text, fnt, Brushes.Red, 66, 20)


    End Sub

    Private Sub Lade_DB()
        connString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Application.StartupPath & "\Hnger.mdb"

        Dim conn As New OleDb.OleDbConnection(connString)
        Dim sql As String = "SELECT * FROM Auswertung ORDER BY Pkt DESC"
        da = New OleDb.OleDbDataAdapter(sql, conn)
        Dim cb As New OleDb.OleDbCommandBuilder(da)

        Try

            da.Fill(ds, "Auswertung")
        Catch ex As System.Exception
            MsgBox(ex.ToString())
            Return
        End Try
        dv = ds.Tables("Auswertung").DefaultView


        DataGridView1.DataSource = dv
        DataGridView1.Columns.Remove("ID")

        TextBox1.DataBindings.Add("Text", dv, "Datum")
        TextBox8.DataBindings.Add("Text", dv, "Name")
        TextBox9.DataBindings.Add("Text", dv, "Pkt")
        TextBox10.DataBindings.Add("Text", dv, "Moves")


    End Sub


    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click


        objCB = New OleDb.OleDbCommandBuilder(da)
        da.UpdateCommand = objCB.GetUpdateCommand

        Try
            Me.BindingContext(dv).EndCurrentEdit()

            Dim m As Integer = da.Update(ds, "Auswertung")
            MessageBox.Show((m.ToString & " Begriff gendert!"), _
              "nderungen erfolgreich bernommen!", MessageBoxButtons.OK, MessageBoxIcon.Information)
            da.Update(ds, "Auswertung")

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Fehler beim Update!", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
        'Zahlzeigen()

    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        Dim msg As String
        Dim title As String
        Dim style As MsgBoxStyle
        Dim response As MsgBoxResult
        msg = "Wollen Sie den Datensatz  " & TextBox8.Text & "  wirklich lschen?"
        style = MsgBoxStyle.DefaultButton2 Or _
           MsgBoxStyle.Critical Or MsgBoxStyle.YesNo
        title = "Lschen"
        response = MsgBox(msg, style, title)
        If response = MsgBoxResult.Yes Then

            If (Me.BindingContext(dv).Count > 0) Then
                Me.BindingContext(dv).RemoveAt(Me.BindingContext(dv).Position)

            End If

            Try
                'Versuch, die Datenquelle zu aktualisieren.
                da.Update(ds, "Auswertung")
            Catch eUpdate As System.Exception
                'Fehlerbehandlungscode hier hinzufgen.
                'Fehlermeldung anzeigen, falls verfgbar.
                System.Windows.Forms.MessageBox.Show(eUpdate.Message)
            End Try

        End If
        If response = MsgBoxResult.No Then Exit Sub
        Zahlzeigen()
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Me.BindingContext(dv).CancelCurrentEdit()

    End Sub

    Private Sub Button10_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click

        TextBox8.Focus()
        Me.BindingContext(dv).Position = dv.Count - 1

        Try
            'Aktuelle Bearbeitungen lschen
            Me.BindingContext(dv).EndCurrentEdit()
            Me.BindingContext(dv).AddNew()
        Catch eEndEdit As System.Exception
            System.Windows.Forms.MessageBox.Show(eEndEdit.Message)
        End Try
        TextBox1.Text = DateTime.Now.ToString("d")
        Me.TextBox8.Text = Hang.TextBox8.Text
        Me.TextBox9.Text = Hang.TextBox9.Text
        Me.TextBox10.Text = Hang.TextBox10.Text

    End Sub


    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Me.BindingContext(dv).Position = dv.Count - 1
        Zahlzeigen()

    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        Me.BindingContext(dv).Position += 10
        Zahlzeigen()

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Me.BindingContext(dv).Position += 1
        Zahlzeigen()

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Me.BindingContext(dv).Position -= 1
        Zahlzeigen()

    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        Me.BindingContext(dv).Position -= 10
        Zahlzeigen()

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.BindingContext(dv).Position = 0
        Zahlzeigen()

    End Sub

    Private Sub DataGridView1_CellFormatting(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellFormattingEventArgs) Handles DataGridView1.CellFormatting


        ' Jede Column bekommt ne eigene Farbe
        If DataGridView1.Columns(e.ColumnIndex).Name = "Name" Then
            e.CellStyle.ForeColor = Color.White
            e.CellStyle.BackColor = Color.Black

        End If

        If DataGridView1.Columns(e.ColumnIndex).Name = "Datum" Then
            e.CellStyle.ForeColor = Color.Black
            e.CellStyle.BackColor = Color.White

        End If

        If DataGridView1.Columns(e.ColumnIndex).Name = "Pkt" Then
            e.CellStyle.ForeColor = Color.Red
            e.CellStyle.BackColor = Color.Yellow

        End If

        If DataGridView1.Columns(e.ColumnIndex).Name = "Moves" Then
            e.CellStyle.ForeColor = Color.White
            e.CellStyle.BackColor = Color.Black

        End If




    End Sub

   
End Class